import Cookie from "js-cookie";

export function isEmail(input: string): boolean {
  const emailRegex = /^[a-zA-Z0-9._%+-]+@[a-zA-Z0-9.-]+\.[a-zA-Z]{2,}$/;
  return emailRegex.test(input);
}

export function NumberFormat(number: number): string {
  return Intl.NumberFormat("fa-IR").format(number);
  // return Intl.NumberFormat("fa-IR").format(number);
}

export const timeAgo = (date: string | Date): string => {
  const now = new Date();
  const past = new Date(date);
  const diff = Math.floor((now.getTime() - past.getTime()) / 1000); // اختلاف بر حسب ثانیه

  const units = [
    { name: "سال", value: 60 * 60 * 24 * 365 },
    { name: "ماه", value: 60 * 60 * 24 * 30 },
    { name: "روز", value: 60 * 60 * 24 },
    { name: "ساعت", value: 60 * 60 },
    { name: "دقیقه", value: 60 },
    { name: "ثانیه", value: 1 },
  ];

  for (const unit of units) {
    const amount = Math.floor(diff / unit.value);
    if (amount >= 1) return `${amount} ${unit.name} پیش`;
  }

  return "همین الان";
};

export const getToken = () => {
  return Cookie.get(import.meta.env.VITE_TOKEN_NAME);
};

export const getRefreshToken = () => {
  return Cookie.get(import.meta.env.VITE_REFRESH_TOKEN_NAME);
};

const isProduction = import.meta.env.MODE === "production";
const domain = isProduction ? ".danakcorp.com" : window.location.hostname;

export const setToken = (token: string) => {
  Cookie.set(import.meta.env.VITE_TOKEN_NAME, token, { domain });
};

export const setRefreshToken = (refreshToken: string) => {
  Cookie.set(import.meta.env.VITE_REFRESH_TOKEN_NAME, refreshToken, { domain });
};

export const removeToken = () => {
  Cookie.remove(import.meta.env.VITE_TOKEN_NAME, { domain, path: "/" });
};

export const removeRefreshToken = () => {
  Cookie.remove(import.meta.env.VITE_REFRESH_TOKEN_NAME, { domain, path: "/" });
};

export const getRedirectUrl = () => {
  const urlParams = new URLSearchParams(window.location.search);
  return urlParams.get("redirect");
};
